<?php
// -----------------------------------------------------------
// GChat Video Chat - http://www.gchat.com/video-chat.html
// Copyright (C) 2013 GChat Limited. All rights reserved.
// GChat Video Chat is not a free software, see LICENSE file
// -----------------------------------------------------------
 
defined('VISICHAT_START') or die("Access Denied");

require_once "IntegrationModule.class.php";

/*
 * Video Chat Dolphin integration class
 *
 */
 class Dolphin extends IntegrationModule
 {
	 
	 private $allowRegistration = false;	 

	 /**
	* Dolphin object constructor
	*
	* @access	public
	*/	
	function __construct()
	{
		parent::__construct(); 
	}
	
	/**
	* Indicates whether when this integration is used, can use register or not.
	*
	* @return boolean
	*/
	public function allowRegistration()
	{
		return $this->allowRegistration;
	}
	
	/**
	* Get the module name
	*
	* @return string
	*/
	public function getName()
	{
		return "Dolphin";
	}
	
	/**
	* Get the module label
	*
	* @return string
	*/
	public function getLabel()
	{
		return "Dolphin";
	}
	
	/**
	* Get user id of the user from session data
	*
	* @return integer
	*/
	public function getCurrentUserId()
	{
		if ( isset ( $_COOKIE["memberID"] ) )
		{
			$user = Factory::getClass("Account")->getUserById ( $_COOKIE["memberID"] );
			
			if ( $user->getPassword() == $_COOKIE["memberPassword"] )
			{
				return $user->getId();
			}
		}
		
		return "";
	}
	
	/**
	* Get picture of the user
	*
	* @return string
	*/
	public function getPicture( $userId )
	{
		return "";
	}
	
	/**
	* Get the user birthday
	*
	* @return timestamp
	*/
	public function getBirthday ( $userId )
	{
		return "";
	}
	
	/**
	* Get the user gender
	*
	* @return string m (male), f (female), n (not specified), c (couple)
	*/
	public function getGender ( $userId )
	{
		return "";
	}
	
	/**
	* Encrypt the user password
	*
	* @return string	encrypted password
	*/
	public function encryptPassword ( $password , $userId = "" )
	{
		
		if ( $userId == "" )
		{
			throw new Exception ("User ID is required");
		}
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");

		// Check the password
		if ( count ( $result ) > 0 && $db->error == "" )
		{
			
			if ( sha1 ( md5 ( $password ) . $result [ 0 ] ["Salt"] ) == $result[0][ $this->passwordField ] )
			{
				return $result[0][ $this->passwordField ];
			}
		}
		
		return "";
	}
 }
 
 
 ?>