<?php
// -----------------------------------------------------------
// GChat Video Chat - http://www.gchat.com/video-chat.html
// Copyright (C) 2013 GChat Limited. All rights reserved.
// GChat Video Chat is not a free software, see LICENSE file
// -----------------------------------------------------------
 
defined('VISICHAT_START') or die("Access Denied");

require_once "IntegrationModule.class.php";

/*
 * Video Chat IPBoard integration class
 *
 */
 class IPBoard extends IntegrationModule
 {
	 
	 private $allowRegistration = false;	 

	 /**
	* IPBoard object constructor
	*
	* @access	public
	*/	
	function __construct()
	{
		parent::__construct(); 
	}
	
	/**
	* Indicates whether when this integration is used, can use register or not.
	*
	* @return boolean
	*/
	public function allowRegistration()
	{
		return $this->allowRegistration;
	}
	
	/**
	* Get the module name
	*
	* @return string
	*/
	public function getName()
	{
		return "IPBoard";
	}
	
	/**
	* Get the module label
	*
	* @return string
	*/
	public function getLabel()
	{
		return "IPBoard";
	}
	
	/**
	* Get user id of the user from session data
	*
	* @return integer
	*/
	public function getCurrentUserId()
	{
		if ( isset ( $_COOKIE["member_id"] )  && isset ( $_COOKIE["pass_hash"] ) )
		{
			// Database instance
			$db = Factory::getDatabase();
			
			$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $_COOKIE["member_id"] ) . "'");
			
			if ( count ( $result ) > 0 )
			{
				if (  $result[0] [ "member_login_key" ] == $_COOKIE["pass_hash"] )
				{
					return $result[0] [ $this->idField ];
				}
			}
		}
		
		return "";
	}
	
	/**
	* Get picture of the user
	*
	* @return string
	*/
	public function getPicture( $userId )
	{
		return "";
	}
	
	/**
	* Get the user birthday
	*
	* @return timestamp
	*/
	public function getBirthday ( $userId )
	{
		
		return "";
	}
	
	/**
	* Get the user gender
	*
	* @return string m (male), f (female), n (not specified), c (couple)
	*/
	public function getGender ( $userId )
	{
		return "n";
	}
	
	/**
	* Encrypt the user password
	*
	* @return string	encrypted password
	*/
	public function encryptPassword ( $password, $userId = "" )
	{
		
		if ( $userId == "" )
		{
			throw new Exception ("User ID is required");
		}
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");
		
		if ( count ( $result ) > 0 )
		{
			if ( md5  ( md5 ( $result [0][ "members_pass_salt"] ) . md5 ( $password ) ) == $result [ 0 ] [ $this->passwordField ] )
			{
				return $result [ 0 ] [ $this->passwordField ];
			}
		
		}
		
		return "";
	}
 }
 
 
 ?>