<?php
// -----------------------------------------------------------
// GChat Video Chat - http://www.gchat.com/video-chat.html
// Copyright (C) 2013 GChat Limited. All rights reserved.
// GChat Video Chat is not a free software, see LICENSE file
// -----------------------------------------------------------
 
defined('VISICHAT_START') or die("Access Denied");

require_once "IntegrationModule.class.php";

/*
 * Video Chat PHPFusion integration class
 *
 */
 class PHPFusion extends IntegrationModule
 {
	 
	 private $allowRegistration = false;	 

	 /**
	* PHPBB object constructor
	*
	* @access	public
	*/	
	function __construct()
	{
		parent::__construct(); 
	}
	
	/**
	* Indicates whether when this integration is used, can use register or not.
	*
	* @return boolean
	*/
	public function allowRegistration()
	{
		return $this->allowRegistration;
	}
	
	/**
	* Get the module name
	*
	* @return string
	*/
	public function getName()
	{
		return "PHPFusion";
	}
	
	/**
	* Get the module label
	*
	* @return string
	*/
	public function getLabel()
	{
		return "PHPFusion";
	}
	
	/**
	* Get user id of the user from session data
	*
	* @return integer
	*/
	public function getCurrentUserId()
	{
		// Edit this
		$cookieName = "xxxxx_user";
		//
		
		$sessionId = "";
		if ( isset ( $_COOKIE[ $cookieName ] ) )
		{
			$sessionData = $_COOKIE[ $cookieName ];
			
			$cookieData = explode( ".", $sessionData );
			
			if ( count ( $cookieData ) == 3 )
			{
				
				$userId = $cookieData [0];
				$timestamp = $cookieData [1];
				$cookieHash = $cookieData [2];
				
				// Database instance
				$db = Factory::getDatabase();
				
				$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");
				
				if ( count ( $result ) > 0 )
				{
					$key = hash_hmac( $result [0]['user_algo'], $userId.$timestamp,  $result [0]["user_salt"]);

					$hash = hash_hmac( $result [0]['user_algo'], $userId.$timestamp, $key);

					if ($cookieHash == $hash)
					{
						return $userId;
					}
				}				
			}
		}
		
		return "";
	}
	
	/**
	* Get picture of the user
	*
	* @return string
	*/
	public function getPicture( $userId )
	{
		//user_avatar
		
		return "";
	}
	
	/**
	* Get the user birthday
	*
	* @return timestamp
	*/
	public function getBirthday ( $userId )
	{
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");
		
		if ( count ( $result ) > 0 )
		{
			return strtotime ( $result [0]["user_birthdate"] );
		}
		
		return "";
	}
	
	/**
	* Get the user gender
	*
	* @return string m (male), f (female), n (not specified), c (couple)
	*/
	public function getGender ( $userId )
	{
		
	}
	
	/**
	* Encrypt the user password
	*
	* @return string	encrypted password
	*/
	public function encryptPassword ( $password, $userId = "" )
	{	
		if ( $userId == "" )
		{
			throw new Exception ("User ID is required");
		}
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");
		
		if ( count ( $result ) > 0 )
		{
			return hash_hmac ( $result[0]["user_algo"] , $password , $result [0]["user_salt"] );
		}
		
		return "";
		
	}
 }
 
 
 ?>