<?php
/*{@@COPYRIGHT@@}*/
 
defined('VISICHAT_START') or die("Access Denied");

/*
 * GChat Video Chat USAePay class
 *
 */
class USAePay
{
	private $name 		= "USAePay";
	private $options	= array();
	private $paymentMethod = NULL;
	private $transactionId = "";
	private $pinCode = "";
	private $testMode = false;
	
	function __construct( $paymentMethod = NULL )
	{
		
		$this->paymentMethod = $paymentMethod;
		$this->options 	 = array();
		$this->options[] = array ("secret_key" => "Secret Key" , "pin_code" => "Pin code");
		$this->transactionId = "";
	}

	//*********************
	// Setters and Getters
	//*********************
	
	/**
	 * Get name of the gateway
	 * 
	 * @return string
	 */ 
	public function getName()
	{
		return $this->name;
	}
	
	/**
	* Get associated payment method
	*
	* @return Payment Method
	*/
	public function getPaymentMethod()
	{
		return $this->paymentMethod;
	}
	
	/**
	* Get options of this gateway
	*
	* @return array
	*/
	public function getOptions()
	{
		return $this->options;
	}
	
	/**
	* Return the transaction id on successful order
	*
	* @return String
	*/
	public function getTransactionId()
	{
		return $this->transactionId;
	}
	
	/**
	* Generate payment form
	*
	* @return string
	*/
	public function getForm( $userId , $referralId )
	{
		
		$invoice = "" ;
		$hashseed = mktime (); 
		$hashdata = "sale:" . $this->getPaymentMethod()->getOption("pin_code") . ":" . round ( $this->getPaymentMethod()->getPrice() , 2 ) . ":" . $invoice . ":" . $hashseed ; 
		$hash = md5 ( $hashdata );
		$UMhash = "m/$hashseed/$hash/y";
		
		$notifyUrl = VISICHAT_URL . 'scripts/pay.php?g=' . $this->getPaymentMethod()->getId() . '&id=' . $userId. '&referral=' . $referralId .'&ac=verify&' ;
		//$returnUrl = VISICHAT_URL . 'scripts/pay.php?g=' . $this->getPaymentMethod()->getId() . '&id=' . $userId. '&referral=' . $referralId .'&res=success&';
		$errorUrl = VISICHAT_URL . 'scripts/pay.php?g=' . $this->getPaymentMethod()->getId() . '&id=' . $userId. '&referral=' . $referralId .'&res=error&' ;
		
		$button = '<form action="https://www.usaepay.com/interface/epayform/">';
		$button .='<input type="hidden" name="UMkey" value="' . $this->getPaymentMethod()->getOption("secret_key") . '">';
		$button .= '<input type="hidden" name="UMhash" value="' . $UMhash . '">';
		$button .= '<input type="hidden" name="UMcommand" value="sale">';
		$button .= '<input type="hidden" name="UMamount" value="' . round ( $this->getPaymentMethod()->getPrice() , 2 ) . '">';
		$button .= '<input type="hidden" name="UMredirDeclined" value="' . $errorUrl . '">';
		$button .= '<input type="hidden" name="UMredirApproved" value="' . $notifyUrl . ' ">';
		$button .= '<input type="hidden" name="UMechofields" value="0" />';
		$button .= '<input type="hidden" name="UMredir" value="' . $notifyUrl . '" />';
		
		if ( $this->testMode )
		{
			$button .= '<input type="hidden" name="UMtestmode" value="1" />';
		}
		
		$button .= '<input type="submit" value="Continue to Payment Form">';
		$button .= '</form>';		
		return $button;
	}
	
	/**
	* Verify if the payment has been sent
	*
	*/
	public function verify()
	{
		
		$this->transactionId = "";
		
 		if ( ! $_REQUEST['UMresponseHash'] )
		{
			return false;
		}
		
		// Check the response hash
		$tmp = explode('/', $_REQUEST['UMresponseHash']);
	
		$gatewaymethod = $tmp[0];
		$gatewayseed = $tmp[1];
		$gatewayhash = $tmp[2];
		$prehash = $this->getPaymentMethod()->getOption("pin_code") . ':' . $_REQUEST["UMresult"] . ':' . $_REQUEST["UMrefNum"] . ':' . $gatewayseed;
	
		if( $gatewaymethod == 'm' )
		{
			$myhash = md5 ( $prehash );
		}
		else if ( $gatewaymethod == 's' )
		{
			$myhash = sha1 ( $prehash );
		}
		else
		{
			return false;
		}
		
		if( $myhash == $gatewayhash )
		{
			$this->transactionId = $_REQUEST['UMresponseHash'];
			
			echo "Your payment has been sent successfully. You can close this window now.";
   			return true;
		}
		
		die ( "There was an error processing your payment. You can close this window now.");
	}
}

?>